<script>
import { GlTab, GlSkeletonLoader } from '@gitlab/ui';
import { s__, __ } from '~/locale';
import { WORKSPACES_LIST_PAGE_SIZE, I18N_LOADING_WORKSPACES_FAILED } from '../constants';
import WorkspacesTable from './workspaces_list/workspaces_table.vue';
import WorkspacesListPagination from './workspaces_list/workspaces_list_pagination.vue';

export const i18n = {
  loadingWorkspacesFailed: I18N_LOADING_WORKSPACES_FAILED,
};

function getTabTitle(tabName) {
  switch (tabName) {
    case 'active':
      return s__('Workspaces|Active');
    case 'terminated':
      return s__('Workspaces|Terminated');
    default:
      throw Error(__('Status not supported'));
  }
}

function getEmptyStateText(tabName) {
  switch (tabName) {
    case 'active':
      return s__('Workspaces|No active workspaces. Create a workspace to get started.');
    case 'terminated':
      return s__('Workspaces|No terminated workspaces to show.');
    default:
      throw Error(__('Status not supported'));
  }
}

export default {
  components: {
    GlTab,
    GlSkeletonLoader,
    WorkspacesTable,
    WorkspacesListPagination,
  },
  props: {
    tabName: {
      type: String,
      required: true,
    },
    workspaces: {
      type: Array,
      required: true,
    },
    pageInfo: {
      type: Object,
      required: true,
    },
    loading: {
      type: Boolean,
      required: true,
    },
  },
  data() {
    return {
      withTableRowTransition: true,
    };
  },
  computed: {
    isEmpty() {
      return !this.workspaces.length && !this.loading;
    },
    transitionProps() {
      const transitionProps = { name: 'fade', delay: 200, duration: 300 };
      return this.withTableRowTransition ? transitionProps : undefined;
    },
  },
  methods: {
    clearError() {
      this.$emit('error', '');
      this.withTableRowTransition = true;
    },
    onUpdateFailed({ error }) {
      // TODO: review type of error, may need to be a different type or cast to string
      this.$emit('error', error);
    },
    onPaginationInput(paginationVariables) {
      this.$emit('onPaginationInput', { tab: this.tabName, paginationVariables });
      this.withTableRowTransition = false;
    },
  },
  i18n,
  WORKSPACES_LIST_PAGE_SIZE,
  getTabTitle,
  getEmptyStateText,
};
</script>
<template>
  <gl-tab
    :data-testid="`workspace-tab-${tabName}`"
    :title="$options.getTabTitle(tabName)"
    :query-param-value="tabName"
  >
    <div v-if="loading" class="gl-p-5 gl-display-flex gl-justify-content-left">
      <gl-skeleton-loader :lines="4" :equal-width-lines="true" :width="600" />
    </div>
    <template v-else>
      <p
        v-if="isEmpty"
        class="gl-display-flex gl-flex-direction-column gl-align-items-center gl-py-6"
        data-testid="empty-state"
      >
        {{ $options.getEmptyStateText(tabName) }}
      </p>

      <div v-else>
        <workspaces-table
          tabs-mode
          :transition-props="transitionProps"
          data-testid="workspace-list-item"
          :workspaces="workspaces"
          @updateFailed="onUpdateFailed"
          @updateSucceed="clearError"
        />
        <workspaces-list-pagination
          :page-info="pageInfo"
          :page-size="$options.WORKSPACES_LIST_PAGE_SIZE"
          @input="onPaginationInput"
        />
      </div>
    </template>
  </gl-tab>
</template>
